<center><a href="ex80.c">Actual source code: ex80.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:29+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Partition tiny grid.\n\n"</font>;

<a name="line4">  4: </a><font color="#B22222">/*T</font>
<a name="line5">  5: </a><font color="#B22222">   Concepts: partitioning</font>
<a name="line6">  6: </a><font color="#B22222">   Processors: 4</font>
<a name="line7">  7: </a><font color="#B22222">T*/</font>

<a name="line9">  9: </a><font color="#B22222">/* </font>
<a name="line10"> 10: </a><font color="#B22222">  Include "petscmat.h" so that we can use matrices.  Note that this file</font>
<a name="line11"> 11: </a><font color="#B22222">  automatically includes:</font>
<a name="line12"> 12: </a><font color="#B22222">     petsc.h       - base PETSc routines   petscvec.h - vectors</font>
<a name="line13"> 13: </a><font color="#B22222">     petscsys.h    - system routines       petscmat.h - matrices</font>
<a name="line14"> 14: </a><font color="#B22222">     petscis.h     - index sets            </font>
<a name="line15"> 15: </a><font color="#B22222">     petscviewer.h - viewers               </font>
<a name="line16"> 16: </a><font color="#B22222">*/</font>
<a name="line17"> 17: </a> #include <A href="../../../../include/petscksp.h.html">petscksp.h</A>

<a name="line21"> 21: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line22"> 22: </a>{
<a name="line23"> 23: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>             A;
<a name="line24"> 24: </a>  <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  ierr;
<a name="line25"> 25: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>     <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line26"> 26: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>        *ia,*ja;
<a name="line27"> 27: </a>  <A href="../../../../docs/manualpages/Mat/MatPartitioning.html#MatPartitioning">MatPartitioning</A> part;
<a name="line28"> 28: </a>  <A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A>              is,isn;

<a name="line30"> 30: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);
<a name="line31"> 31: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line32"> 32: </a>  <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/size.html#size">size</A> != 4) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Must run with 4 processors"</font>);
<a name="line33"> 33: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line35"> 35: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(5*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;ia);
<a name="line36"> 36: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(16*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;ja);
<a name="line37"> 37: </a>  <font color="#4169E1">if</font> (!<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>) {
<a name="line38"> 38: </a>    ja[0] = 1; ja[1] = 4; ja[2] = 0; ja[3] = 2; ja[4] = 5; ja[5] = 1; ja[6] = 3; ja[7] = 6;
<a name="line39"> 39: </a>    ja[8] = 2; ja[9] = 7;
<a name="line40"> 40: </a>    ia[0] = 0; ia[1] = 2; ia[2] = 5; ia[3] = 8; ia[4] = 10;
<a name="line41"> 41: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> == 1) {
<a name="line42"> 42: </a>    ja[0] = 0; ja[1] = 5; ja[2] = 8; ja[3] = 1; ja[4] = 4; ja[5] = 6; ja[6] = 9; ja[7] = 2;
<a name="line43"> 43: </a>    ja[8] = 5; ja[9] = 7; ja[10] = 10; ja[11] = 3; ja[12] = 6; ja[13] = 11;
<a name="line44"> 44: </a>    ia[0] = 0; ia[1] = 3; ia[2] = 7; ia[3] = 11; ia[4] = 14;
<a name="line45"> 45: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> == 2) {
<a name="line46"> 46: </a>    ja[0] = 4; ja[1] = 9; ja[2] = 12; ja[3] = 5; ja[4] = 8; ja[5] = 10; ja[6] = 13; ja[7] = 6;
<a name="line47"> 47: </a>    ja[8] = 9; ja[9] = 11; ja[10] = 14; ja[11] = 7; ja[12] = 10; ja[13] = 15;
<a name="line48"> 48: </a>    ia[0] = 0; ia[1] = 3; ia[2] = 7; ia[3] = 11; ia[4] = 14;
<a name="line49"> 49: </a>  } <font color="#4169E1">else</font> {
<a name="line50"> 50: </a>    ja[0] = 8; ja[1] = 13; ja[2] = 9; ja[3] = 12; ja[4] = 14; ja[5] = 10; ja[6] = 13; ja[7] = 15;
<a name="line51"> 51: </a>    ja[8] = 11; ja[9] = 14;
<a name="line52"> 52: </a>    ia[0] = 0; ia[1] = 2; ia[2] = 5; ia[3] = 8; ia[4] = 10;
<a name="line53"> 53: </a>  }

<a name="line55"> 55: </a>  <A href="../../../../docs/manualpages/Mat/MatCreateMPIAdj.html#MatCreateMPIAdj">MatCreateMPIAdj</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,4,16,ia,ja,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;A);
<a name="line56"> 56: </a>  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(A,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);

<a name="line58"> 58: </a>  <font color="#B22222">/*</font>
<a name="line59"> 59: </a><font color="#B22222">       Partition the graph of the matrix </font>
<a name="line60"> 60: </a><font color="#B22222">  */</font>
<a name="line61"> 61: </a>  <A href="../../../../docs/manualpages/MatOrderings/MatPartitioningCreate.html#MatPartitioningCreate">MatPartitioningCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;part);
<a name="line62"> 62: </a>  <A href="../../../../docs/manualpages/MatOrderings/MatPartitioningSetAdjacency.html#MatPartitioningSetAdjacency">MatPartitioningSetAdjacency</A>(part,A);
<a name="line63"> 63: </a>  <A href="../../../../docs/manualpages/MatOrderings/MatPartitioningSetFromOptions.html#MatPartitioningSetFromOptions">MatPartitioningSetFromOptions</A>(part);
<a name="line64"> 64: </a>  <font color="#B22222">/* get new processor owner number of each vertex */</font>
<a name="line65"> 65: </a>  <A href="../../../../docs/manualpages/MatOrderings/MatPartitioningApply.html#MatPartitioningApply">MatPartitioningApply</A>(part,&amp;is);
<a name="line66"> 66: </a>  <font color="#B22222">/* get new global number of each old global number */</font>
<a name="line67"> 67: </a>  <A href="../../../../docs/manualpages/IS/ISPartitioningToNumbering.html#ISPartitioningToNumbering">ISPartitioningToNumbering</A>(is,&amp;isn);
<a name="line68"> 68: </a>  <A href="../../../../docs/manualpages/IS/ISView.html#ISView">ISView</A>(isn,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);
<a name="line69"> 69: </a>  <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(is);

<a name="line71"> 71: </a>  <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(isn);
<a name="line72"> 72: </a>  <A href="../../../../docs/manualpages/MatOrderings/MatPartitioningDestroy.html#MatPartitioningDestroy">MatPartitioningDestroy</A>(part);

<a name="line74"> 74: </a>  <font color="#B22222">/*</font>
<a name="line75"> 75: </a><font color="#B22222">       Free work space.  All PETSc objects should be destroyed when they</font>
<a name="line76"> 76: </a><font color="#B22222">       are no longer needed.</font>
<a name="line77"> 77: </a><font color="#B22222">  */</font>
<a name="line78"> 78: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);


<a name="line81"> 81: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line82"> 82: </a>  <font color="#4169E1">return</font> 0;
<a name="line83"> 83: </a>}

</pre>
</body>

</html>
